----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:26:37 05/16/2012 
-- Design Name: 
-- Module Name:    RAM1 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
USE ieee.numeric_std.ALL;
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity RAM2 is
    Port (  clk : in STD_LOGIC;
				addrWrite : in  STD_LOGIC_VECTOR (9 downto 0);
           dataWrite : in  STD_LOGIC_VECTOR (7 downto 0);
           addrRead : in  STD_LOGIC_VECTOR (9 downto 0);
           dataRead : out  STD_LOGIC_VECTOR (7 downto 0);
			  dReady : out STD_LOGIC
			  );
end RAM2;

architecture Behavioral of RAM2 is
type ram_type IS ARRAY(0 to 1023) OF STD_LOGIC_VECTOR(7 downto 0);
signal ram : ram_type;

signal flag : std_logic := '0';

begin

	process(addrRead)
	begin
	--	dReady <= '0';
		dataRead <= ram(to_integer(unsigned(addrRead)));
	
	flag <= '1';
		dReady <= flag;
	
	end process;
	
	process(addrWrite)
	begin
		ram(to_integer(unsigned(addrWrite))) <= dataWrite;
	end process;
	
	process(clk)
	begin
	if (clk'event and clk='1') then
		flag <= '0';
			end if;
	dReady <= flag;
	
	end process;

end Behavioral;

