t = 0:(1/20000):1;
x = sin(2*pi*200*t) + sin(2*pi*3000*t) + sin(2*pi*6500*t) + sin(2*pi*9000*t);

load('PADAWAN.mat');
load('PADAWAN_GOLD.mat');

subplot(5,1,1);plot([x(1:400)]);
xlabel('Time [samples]');ylabel('Amplitude'); title('Input Stimulus');
subplot(5,1,2);plot(yy1(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Filtered Output');
subplot(5,1,3);plot(yy2(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Filtered Output');
subplot(5,1,4);plot(yy3(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Filtered Output');
subplot(5,1,5);plot(yy4(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Filtered Output');

figure
subplot(3,1,1);plot([x(1:400)]);
xlabel('Time [samples]');ylabel('Amplitude'); title('Input Stimulus');
y = (double(y1)+double(y2)./4+double(y3)+double(y4)./4);
subplot(3,1,2);plot(y(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Golden Filtered Output');
yy = (yy1+yy2+yy3+yy4);
subplot(3,1,3);plot(yy(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Actual Filtered Output');


figure,plot(abs( fftshift( fft( double(yy) ) ) ))
figure,plot(abs(fftshift(fft(x))))