t = 0:(1/20000):1;
x = sin(2*pi*200*t) + sin(2*pi*3000*t) + sin(2*pi*6500*t) + sin(2*pi*9000*t);
filterDesigner;

tstart=tic;
H1.PersistentMemory = true;
y1 = filter(H1,x); 
y2 = filter(H2,x); 
y3 = filter(H3,x); 
y4 = filter(H4,x); 
telapsed = toc(tstart)

subplot(5,1,1);plot([x(1:400)]);
xlabel('Time [samples]');ylabel('Amplitude'); title('Input Stimulus');
subplot(5,1,2);plot(y1(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Filtered Output');
subplot(5,1,3);plot(y2(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Filtered Output');
subplot(5,1,4);plot(y3(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Filtered Output');
subplot(5,1,5);plot(y4(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Filtered Output');

figure
subplot(2,1,1);plot([x(1:400)]);
xlabel('Time [samples]');ylabel('Amplitude'); title('Input Stimulus');
y = double(y1)+double(y2)+double(y3)+double(y4)./4;
subplot(2,1,2);plot(y(1:400));
xlabel('Time [samples]');ylabel('Amplitude'); title('Filtered Output');

figure,plot(abs(fftshift(fft((double(y1)+double(y2)+double(y3)+double(y4))./4))))
figure,plot(abs(fftshift(fft(x))))